//*************************************************************
//                          DEMO.C   
// bLCDĤ@ Welcome to PIC     
// bLCDĤG Micro-Controller 
//*************************************************************
#include 	<p18f4520.h> 	//ǤJLwq
#include 	<delays.h> 		//ǤJɶ禡wwq
#include 	<adc.h>			//ǤJTഫ禡wwq
#include 	<timers.h>		//ǤJpɾ禡wwq
#include 	<pwm.h>			//ǤJPWM禡wwq
#include 	<stdlib.h>		//ǤJзǨ禡w禡쫬W٩wq
#include 	<ctype.h>		//ǤJrŸ禡w禡쫬W٩wq
#include 	<i2c.h>			//ǤJI2C禡w禡쫬W٩wq
#include 	<usart.h>		//ǤJpɾUSARTqT禡wwq
#include 	"evm_lcd.h"		//ǤJLCD禡wwq

// ]wLBzc줸
#pragma config	OSC=HS, BOREN=OFF, BORV = 2, PWRT=ON, WDT=OFF, LVP=OFF
//, CCP2MX = PORTBE

// wqɧWv
#define OSC_CLOCK 10

// ŧiɶ禡쫬
void delay_ms(long);
void rot_right(void);
void rot_left(void);
void put_Num_LCD( unsigned char);

// ŧiɶܼƨêlƬ0
unsigned char hour=0, min=0, sec=0;
// AXܼ
struct Flag{
	unsigned update :1; //	One Second Passed
	unsigned TxD :1; //	UART Tx Continue
} FLAGbits;

// ŧiTIMER1pɾ_{
void timer1_isr (void);
void Rx_isr (void);

#pragma code high_vector=0x08
void high_interrupt (void)
{
_asm GOTO timer1_isr _endasm
}

#pragma code

#pragma interrupt timer1_isr
void timer1_isr (void)
{
	PIR1bits.TMR1IF = 0;		// M_X
	WriteTimer1(0x8000);		// ]wpɾl
	FLAGbits.update=1;			// ]wsX
}

#pragma code low_vector=0x18
void low_interrupt (void)
{
_asm GOTO Rx_isr _endasm
}
#pragma code

#pragma interruptlow Rx_isr

void Rx_isr (void)
{
	PIR1bits.RCIF = 0;		// M_X
	ReadUSART();			// ŪUSARTƦ줸
	FLAGbits.TxD=1;			// ]wX
}

#define I2C_TCN75A_address 0x98  // TCN75A I2C Device Address

void main() {
	unsigned char Temp[2];
	char char_str[5]={0,0,0,0,0};

	FLAGbits.update=0;
	FLAGbits.TxD=0;

	OpenLCD();					// lLCDҲ

	WriteCmdLCD( 0x01 );			// MLCDܸ
	LCD_Set_Cursor( 0, 0 );		// ܦm^ܲ00
	delay_ms(1);					// ɶ
	putrsLCD("Welcome to PIC");	// ܸ
	LCD_Set_Cursor( 1, 0 );		// ܦmզܲ10
	delay_ms(1);					// ɶ
	putrsLCD("Micro-Controller");// ܸ

	delay_ms(1000);

	PORTD = 0x01;			// NPORTD]wIGLED0
	TRISD = 0; 				// NTRISD]0APORTD]wX
	ADCON1=0x0C;			// ]wAN0~2J
	TRISAbits.TRISA4=1;		// ]wRA4ƦJ}
	TRISBbits.TRISB0=1;		// ]wRB0ƦJ}

	// }TഫҲ
	OpenADC(ADC_FOSC_32 & ADC_LEFT_JUST & ADC_20_TAD,
			ADC_CH0 & ADC_INT_OFF & ADC_VREFPLUS_VDD & 
			ADC_VREFMINUS_VSS, 12);

	TRISCbits.TRISC2 = 0;	// ]wCCP1X
	TRISBbits.TRISB3 = 0;	// ]wCCP2X
	OpenPWM1(0x9B);   		// ]wCCP1PWM\PɯߩP
	OpenPWM2(0x9B);   		// ]wCCP2PWM\PɯߩP
	OpenTimer2(TIMER_INT_OFF&T2_PS_1_4&T2_POST_1_1); //}TIMER2
/*
	OpenI2C(MASTER, SLEW_ON);// lI2CҲ
	SSPADD = 0x19;	//400Khz Baud clock(0x19) @10MHz
					//100khz Baud clock(0x3F) @10MHz

	EEByteWrite(I2C_TCN75A_address, 0x01, 0x00); // lTCN75AҲլ9bitҦ
	char_str[0]=34;				//]wūĵܤW=char_str[0]+char_str[1]/256
	char_str[1]=128;			//bit7@
	EEPageWrite(I2C_TCN75A_address, 0x03, char_str); // ]wūĵܤW
	char_str[0]=33;				//]wūĵܸѰU=char_str[0]+char_str[1]/256
	char_str[1]=128;			//bit7@
	EEPageWrite(I2C_TCN75A_address, 0x02, char_str); // ]wūĵܸѰU
*/
   OpenUSART( 	USART_TX_INT_OFF &	//}USARTqT
				USART_RX_INT_ON &	//]w8-N-1-9600Ҧ
				USART_ASYNCH_MODE &	//}ҸƱ_\
				USART_EIGHT_BIT &
				USART_CONT_RX &
				USART_BRGH_HIGH,
				64 );
// The Baud Rate is Fosc/(64*(spbrg+1)); for Low Speed
// The Baud Rate is Fosc/(16*(spbrg+1)); for High Speed
// 64 and High is 9600
	PIR1bits.RCIF = 0;		// M_X
	IPR1bits.RCIP = 0;		// ]wCu_

// lƭpɾTimer1
	OpenTimer1( TIMER_INT_ON &
				T1_16BIT_RW &
				T1_SOURCE_EXT &
				T1_PS_1_1 &
				T1_OSC1EN_ON &
				T1_SYNC_EXT_OFF );
	WriteTimer1(0x8000); 		//0x8000=1sec @32786Hz Crystal
	PIR1bits.TMR1IF = 0;		// M_X
	IPR1bits.TMR1IP = 1;		// ]wu_

	RCONbits.IPEN=1;			// }Ҥ_u\
    INTCONbits.GIEL = 1;		// }ҧCu_\
	INTCONbits.GIEH = 1;		// }Ұu_\

	LCD_Set_Cursor( 1, 0 );		// ܦm^ܲ00
	delay_ms(1);					// ɶ
	putrsLCD("S2:MORE S3:LED  ");	// ܸ

	while (PORTBbits.RB0==1) {			

	delay_ms(100);			// 100ms
	if(PORTAbits.RA4==0)	// UɡAV
		rot_left();
	else					// _hAVk
		rot_right();
	}

	WriteCmdLCD( 0x01 );			// MLCDܸ
	delay_ms(1);					// ɶ
	LCD_Set_Cursor( 0, 0 );		// ܦm^ܲ00
	delay_ms(1);					// ɶ
	putrsLCD("V1:??? V2:??? S");	// ܸ
	LCD_Set_Cursor( 1, 0 );		// ܦm^ܲ00
	putrsLCD("0:0:0");		// lLCD

	while(1){
	SetChanADC(ADC_CH0);
	ConvertADC() ;		// iTഫ
	while(BusyADC());		// ഫ
	LCD_Set_Cursor( 0, 3);		// ܦm^ܲ00
	put_Num_LCD( ADRESH );
	SetDCPWM1((unsigned int)ADRESH<<2); // վPWMu@g

	SetChanADC(ADC_CH1);
	ConvertADC() ;		// iTഫ
	while(BusyADC());		// ഫ
	LCD_Set_Cursor( 0, 10);		// ܦm^ܲ00
	put_Num_LCD( ADRESH );
	SetDCPWM2((unsigned int)ADRESH<<2); // վPWMu@g

	LCD_Set_Cursor( 0, 15);		// ܦm^ܲ00
	SetChanADC(ADC_CH2);
	ConvertADC() ;			// iAN2Tഫ
	while(BusyADC());		// ഫ
	if (ADRESH == 0) putcLCD('4');	// ھഫGMwĲo
	else 
	{	if(ADRESH < 128) putcLCD('5');
		else 
		{	if(ADRESH < 170) putcLCD('6');
			else putcLCD(' ');
		}
	}

	if(FLAGbits.update) {
		++sec;							// Nƻ[
		if (sec >= 60) {				// @iBz
			sec-=60;
	    	min++;
 		}
		if (min >= 60) {
	 		min-=60;
			hour++;
		}
		if ( hour > 24 ) hour=0;
		LCD_Set_Cursor( 1, 0 );		// վܦ}
		delay_ms(1);
		putrsLCD("        ");
		delay_ms(1);
		LCD_Set_Cursor( 1, 0 );		// վܦ}
		delay_ms(1);
		putsLCD(btoa(hour, char_str));	// ܮɶ
		putcLCD(':');
		putsLCD(btoa(min, char_str));
		putcLCD(':');
		putsLCD(btoa(sec, char_str));

//		EESequentialRead(I2C_TCN75A_address, 0x00, Temp, 2); //Ūū׭
		LCD_Set_Cursor( 1, 9 );		// վܦ}
		putsLCD(btoa(Temp[0], char_str));
		putcLCD(0xDF);
		putcLCD('C');

		if(FLAGbits.TxD){
			putrsUSART("Welcome to PIC! ");
			FLAGbits.TxD=0;
		}

		FLAGbits.update=0;			// MsX

	}

	}
}

// ɶ禡
void delay_ms(long A) {
//This function is only good for OSC_CLOCK higher than 4MHz
	long i;
	int us2TCY;
	us2TCY=(10*OSC_CLOCK)>>2;
	for(i=0;i<A;i++) Delay100TCYx(us2TCY);		
}

void rot_right(void) {

	if(PORTD>1)				// PORTD>1AVk
		PORTD=(PORTD>>1);
	else					// PORTD=1A^kRD7
		PORTD=0x80;
}

void rot_left(void) {

	if(PORTD<128)			// PORTD<128AV
		PORTD=(PORTD<<1);
	else					// PORTD>=128A^kRD0
		PORTD=0X01;
}

//***********************************************
//    Put a byte in decimal format to LCD Module
//	  0~99 Only. Uncomment the first 2 lines for hundreds

void	put_Num_LCD( unsigned char The_Number )
{

	unsigned char	Temp_Char_100, Temp_Char_10, Temp_Char ;

		Temp_Char_100 = The_Number /100 ;		//ʦƪƦr
		putcLCD( Temp_Char_100 + '0' ) ;			//ഫASCIIsXA'0'sX[Ʀrjp
		Temp_Char_10 = (The_Number - Temp_Char_100*100)  /10 ;		//QƪƦr
		putcLCD( Temp_Char_10 + '0' ) ;
		Temp_Char = The_Number - ( Temp_Char_100*100 + Temp_Char_10 * 10 ) ;	//ӦƪƦr
		putcLCD( Temp_Char + '0' ) ;
}
